function C = C(y,x)
%vpocet meridianov konvergence C
%C = C(y,x)

e2 = 0.006674372230622;
a = 6377397.15508;
e = sqrt(e2);

ro = 180/pi;
S0 = 78.5;
r0 = 0.9999 * 6380703.6105 * 1/tan(78.5/ro);

k = 1/0.9965924867;

%Polarni souradnice
r = (y^2 + x^2)^0.5;
epsilon = ro*atan2(y,x);
if(epsilon < 0)
    epsilon = 360 + epsilon;
end

%Kartograficka sirka a delka
D1 = ro * (epsilon/ro) / (sin(S0/ro));    %sirka

S1 = ro * 2 * (atan( (tan((S0/2 + 45)/ro)) / ((r/r0)^(1/sin(S0/ro))) ) - 45/ro);   %delka


% Zemepisna sirka a delka na referencni kouli
%pol zobrazeni:
%Uk = 59 42 42.69690
%Vk = 42 31 31.41725

Uk = dms2deg(mat2dms([59 42 42.69690]));
Vk = dms2deg(mat2dms([42 31 31.41725]));

U = ro * asin((sin(S1/ro)) * (sin(Uk/ro)) - (cos(S1/ro)) * (cos(Uk/ro)) * (cos(D1/ro)));

V = Vk - ro * asin((cos(S1/ro)*sin(D1/ro)) / (cos(U/ro)));

%Zemepisna sirka na Besselove elipsoidu
U0 = dms2deg(mat2dms([49 27 35.84625]));
DU = U - U0;
fi = (100.1416022789e-2)*(DU) - (86.87150417e-6)*(DU^2) + (16.70197e-8)*(DU^3) + (117.5089e-10)*(DU^4) + 49.5;
alfa = 1.000597498372;

% % fi=0;
% % for wqw=1:10
% % fi = 2*ro*atan(  ( (k*tan((U/2 + 45)/ro))^(1/alfa)  )*(  (   (1 + e*sin(fi/ro))/(1 - e*sin(fi/ro))  )^(e/2)  )      ) - 90
% % end


                                  %[17 39 59.7354] presn hodnota Ferro - Greenwich
lamda = V/alfa;% - dms2deg(mat2dms([17 40 00]));     %!!! Ferro NE!!!


%Meridinov konvegence C

ksi = ro * acos(((cos((90-Uk)/ro)-cos((90-U)/ro)*cos(((90-S1)/ro))))/(sin((90-U)/ro)*sin(((90-S1)/ro))));
C = epsilon - ksi;
