function [deltaAB,deltaBA] = deltaAB(yA,xA,yB,xB)
%smerov korekce
%[deltaAB,deltaBA] = deltaAB(yA,xA,yB,xB)
%
%vsledek je v sedestinnch vterinch ('')

ro = 180/pi;
rov = (180*60*60)/pi;

S0 = 78.5;
R0 = 0.9999 * 6380703.6105 * 1/tan(78.5/ro);%1298039.0046

R1 = (yA^2 + xA^2)^0.5;
R2 = (yB^2 + xB^2)^0.5;

%DR1 = R1 - R0;
%DR2 = R2 - R0;

%--- K1 ---
S1 = ro * 2 * (atan( (tan((S0/2 + 45)/ro)) / ((R1/R0)^(1/sin(S0/ro))) ) - 45/ro);   %sfrick delka
K1 = (sin(S0/ro) - sin(S1/ro))/(6*sin(S0/ro));
%--- K1 END ---

%--- K2 ---
S2 = ro * 2 * (atan( (tan((S0/2 + 45)/ro)) / ((R2/R0)^(1/sin(S0/ro))) ) - 45/ro);   %sfrick delka
K2 = (sin(S0/ro) - sin(S2/ro))/(6*sin(S0/ro));
%--- K2 END ---

D1 = ro*atan2(yA,xA);
if(D1 < 0)
    D1 = 360 + D1;
end

D2 = ro*atan2(yB,xB);
if(D2 < 0)
    D2 = 360 + D2;
end

DD = D2 - D1;

%-------------
S = ((yA - yB)^2 + (xA - xB)^2)^0.5;%s12
Rm = ( ((yA + yB)/2)^2 + ((xA + xB)/2)^2 )^0.5;
Dm = (D1 + D2)/2;

sigma12 = ro*atan2(yB-yA,xB-xA);
if(sigma12 < 0)
    sigma12 = 360 + sigma12;
end

sigma21 = sigma12 - 180;

%-------------
% deltaAB =  rov * sin(DD/ro) * (2*K1*R2/R1 +   K2*R1/R2);
% deltaBA = -rov * sin(DD/ro) * (  K1*R2/R1 + 2*K2*R1/R2);

deltaAB =  rov * sin( DD/ro) * (2*K1*R2/R1 +   K2*R1/R2) + 356 * ((S^3)/(Rm^3)) * sin(3*(sigma12/ro - Dm/ro));
deltaBA =  rov * sin(-DD/ro) * (  K1*R2/R1 + 2*K2*R1/R2) + 356 * ((S^3)/(Rm^3)) * sin(3*(sigma21/ro - Dm/ro));
