function tab = odlehlost(yA,xA,yB,xB,poc_int)
%odlehlost geodetick krivky
%odlehlost(yA,xA,yB,xB,poc_int)
%
%poc_int = pocet intervalu (vypoctenych bodu)
%tab je Mat: sloupec 1 = vzdalenost od bodu A
%            sloupec 2 = odlehlost

do = poc_int;%pocet intervalu

S0 = 78.5;
ro = 180/pi;

n = sin(S0/ro);

S = ( (xA-xB)^2 + (yA-yB)^2 )^0.5;%dlka krivky

%azimut
aA = azimutAB(yA,xA,yB,xB);%poctecn
aB = azimutAB(yB,xB,yA,xA) + 180;%koncov
if(aB > 360)
    aB = aB - 360;
end

da = (aB - aA)/do;%krok


%sfrick dlka
SA = Si(yA,xA);%poctecn
SB = Si(yB,xB);%koncov

dS = (SB - SA)/do;%krok


%vzdlenost od poctku
roA = (yA^2 + xA^2)^0.5;
roB = (yB^2 + xB^2)^0.5;

dro = (roB - roA)/do;

% fprintf(1,'bod    vzdlenost [m]   odlehlost [m] \n')
% fprintf(1,'-------------------------------------\n')

tab = [];

for i=0:1:do;
      s = i*S/do;
     Si = SA + i*dS;
     ai = aA + i*da;
    roi = roA + i*dro;
    
     G0 = ((sin(Si/ro) - sin(S0/ro)) / (sin(S0/ro) * roi))*sin(ai/ro);%GAMMA
     G1 = ((sin(2*ai/ro))/(2 * n^2 * roi^2))*(1 - n^2);    %GAMMA' (na kouli)
     
      d = (G0/2)*(S-s)*s + (G1/6)*(S^2-s^2)*s;

    %fprintf(1,'%2.f %10.3f %9.4f %.6f %.6f %.3f\n',i,s,d,Si,ai,roi);
    %fprintf(1,'%2.f \t %10.3f \t %9.4f\n',i,s,d)
    
    tab(end+1,1) = s;
    tab(end,2) = d;
end
