%VG11 uloha 4.1 az 3 (Smerov korekce v krovakove zobrazen)
%RSC (rsc@email.cz)

clear %vymazani pameti
clc %smazani obrazovky

%tic;%stopky


fid = fopen('4.1az3.txt','w'); %vytvoreni *.txt souboru pro vystup


ro = 180/pi;

fprintf(fid,'VG11 - uloha 4\n');
fprintf(fid,'--------------\n\n');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%vstupn hodnoty
w1 = dms2deg(mat2dms([66 25 41.576]));
w2 = dms2deg(mat2dms([61 58 55.968]));

yA = 647075.6;
xA = 1096862.014;

yB = 632112.622;
xB = 1126887.255;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


fprintf(fid,'Zadan hodnoty\n');
fprintf(fid,'------------------------------\n');
fprintf(fid,'yA = %12.3f m\n',yA);
fprintf(fid,'xA = %12.3f m\n',xA);
fprintf(fid,'yB = %12.3f m\n',yB);
fprintf(fid,'xB = %12.3f m\n',xB);

fprintf(fid,'w1 = %4.f %2.f'' %6.3f'''' \n',dms2mat(deg2dms(w1)));
fprintf(fid,'w2 = %4.f %2.f'' %6.3f'''' \n',dms2mat(deg2dms(w2)));
fprintf(fid,'------------------------------\n\n');

fprintf(fid,'Vypocten hodnoty\n');
fprintf(fid,'------------------------------\n');
fprintf(fid,'\n\n=======================================================\n');
fprintf(fid,'\t\tcst 4.1\n');
fprintf(fid,'=======================================================\n');



fprintf(fid,'Smerov korekce:\n\n');

[dAB,dBA] = deltaAB(yA,xA,yB,xB);
fprintf(fid,'\tdAB = %+8.5f''''\n',dAB);
fprintf(fid,'\tdBA = %+8.5f''''\n\n',dBA);



w1o = w1;
w2o = w2;

for i=1:5;
    [yC,xC] = pro_uhel(yA,xA,yB,xB,w1o/ro,w2o/ro);
    
    [dAC,dCA] = deltaAB(yA,xA,yC,xC);
    [dBC,dCB] = deltaAB(yB,xB,yC,xC);
    
    w1o = w1 - dAC/3600 + dAB/3600;
    w2o = w2 - dBA/3600 + dBC/3600;
end

fprintf(fid,'\tdAC = %+8.5f''''\n',dAC);
fprintf(fid,'\tdCA = %+8.5f''''\n\n',dCA);

fprintf(fid,'\tdBC = %+8.5f''''\n',dBC);
fprintf(fid,'\tdCB = %+8.5f''''\n\n',dCB);



fprintf(fid,'Redukovan hly:\n\n');
fprintf(fid,'\tw1 = %4.f %2.f'' %8.5f'''' \n',dms2mat(deg2dms(w1o)));
fprintf(fid,'\tw2 = %4.f %2.f'' %8.5f'''' \n',dms2mat(deg2dms(w2o)));
w3o = 180 - w1o - w2o;
fprintf(fid,'\tw3 = %4.f %2.f'' %8.5f'''' \n\n',dms2mat(deg2dms(w3o)));


fprintf(fid,'Sfrick exces:\n\n');
w3 = w3o - dCA/3600 + dCB/3600;
%fprintf(fid,'\tw3 = %4.f %2.f'' %8.5f'''' \n\n',dms2mat(deg2dms(w3)));

Sw = w1 + w2 + w3 - 180;
fprintf(fid,'\te1 = %4.f %2.f'' %8.4f'''' (z korekc)\n',dms2mat(deg2dms(Sw)));

rov = (180*60*60)/pi;
R = 6380000;
P = abs(((xB-xA)*(yC-yA)-(xC-xA)*(yB-yA))/2);
Sw2 = (P/R^2)*rov;

fprintf(fid,'\te2 = %4.f %2.f'' %8.4f'''' (z plochy)\n\n',[0,0,Sw2]);



fprintf(fid,'Bod C:\n\n');
fprintf(fid,'\tyC = %12.4f m\n',yC);
fprintf(fid,'\txC = %12.4f m\n',xC);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf(fid,'\n\n=======================================================\n');
fprintf(fid,'\t\tcst 4.2\n');
fprintf(fid,'=======================================================\n');


S = 40000;
poc = 10;%pocet bodu ve kterych se bude poctat odlehlost
hold on;
axis equal;
%-------- strana AB
tabA = odlehlost(yA,xA,yB,xB,poc);


fprintf(fid,'-----------------------------\n');
fprintf(fid,'strana AB\n');
fprintf(fid,'---------------------------------------------------------\n');
fprintf(fid,'vzdlenost [m]  odlehlost [m]        y [m]          x [m]\n');
fprintf(fid,'-----------------------------------------------------------\n');


%S = ((((xA-xB)^2 + (yA-yB)^2)^0.5)/15)/max(abs(tabA(:,2)));

tabA2 = transformace2Dpod(yA,xA,yB,xB,tabA(1,2),tabA(1,1),tabA(end,2),tabA(end,1),S*tabA(:,2),tabA(:,1));

for i=1:poc+1
    fprintf(fid,'%12.3f \t %+8.3f \t %12.3f \t %12.3f\n',tabA(i,:),tabA2(i,:));
end


plot(-tabA2(:,1),-tabA2(:,2))

%-------- strana BC
tabA = odlehlost(yB,xB,yC,xC,poc);

fprintf(fid,'-----------------------------\n');
fprintf(fid,'strana BC\n');
fprintf(fid,'---------------------------------------------------------\n');
fprintf(fid,'vzdlenost [m]  odlehlost [m]        y [m]          x [m]\n');
fprintf(fid,'-----------------------------------------------------------\n');

tabA2 = transformace2Dpod(yB,xB,yC,xC,tabA(1,2),tabA(1,1),tabA(end,2),tabA(end,1),S*tabA(:,2),tabA(:,1));

for i=1:poc+1
    fprintf(fid,'%12.3f \t %+8.3f \t %12.3f \t %12.3f\n',tabA(i,:),tabA2(i,:));
end

plot(-tabA2(:,1),-tabA2(:,2))

%-------- strana CA
tabA = odlehlost(yC,xC,yA,xA,poc);
fprintf(fid,'-----------------------------\n');
fprintf(fid,'strana CA\n');
fprintf(fid,'---------------------------------------------------------\n');
fprintf(fid,'vzdlenost [m]  odlehlost [m]        y [m]          x [m]\n');
fprintf(fid,'-----------------------------------------------------------\n');

tabA2 = transformace2Dpod(yC,xC,yA,xA,tabA(1,2),tabA(1,1),tabA(end,2),tabA(end,1),S*tabA(:,2),tabA(:,1));

for i=1:poc+1
    fprintf(fid,'%12.3f \t %+8.3f \t %12.3f \t %12.3f\n',tabA(i,:),tabA2(i,:));
end

plot(-tabA2(:,1),-tabA2(:,2))


%-------- trojuhelnk
plot(-[yA,yB,yC,yA],-[xA,xB,xC,xA],'r')
text(-yA,-xA,'A')
text(-yB,-xB,'B')
text(-yC,-xC,'C')


fprintf(fid,'\n\n=======================================================\n');
fprintf(fid,'\t\tcst 4.3\n');
fprintf(fid,'=======================================================\n');

fprintf(fid,'azimuty geodetickch krivek:\n');

aAB = azimutAB(yA,xA,yB,xB);
fprintf(fid,'\n\talfaAB = %4.f %2.f'' %8.5f'''' \n',dms2mat(deg2dms(aAB)));
aBA = azimutAB(yB,xB,yA,xA);
fprintf(fid,'\talfaBA = %4.f %2.f'' %8.5f'''' \n',dms2mat(deg2dms(aBA)));


aBC = azimutAB(yB,xB,yC,xC);
fprintf(fid,'\n\talfaBC = %4.f %2.f'' %8.5f'''' \n',dms2mat(deg2dms(aBC)));
aCB = azimutAB(yC,xC,yB,xB);
fprintf(fid,'\talfaCB = %4.f %2.f'' %8.5f'''' \n',dms2mat(deg2dms(aCB)));


aCA = azimutAB(yC,xC,yA,xA);
fprintf(fid,'\n\talfaCA = %4.f %2.f'' %8.5f'''' \n',dms2mat(deg2dms(aCA)));
aAC = azimutAB(yA,xA,yC,xC);
fprintf(fid,'\talfaAC = %4.f %2.f'' %8.5f'''' \n',dms2mat(deg2dms(aAC)));

axis off;
print -dpng 4.2.png; %automaticky export do *.png

fclose(fid);
fprintf('\n\nCiselne vysledky jsou ulozeny v souboru "4.1az3.txt"\n v pracovnim adresari, graf jako obrazek "4.2.png"');